require 'redmine'
require 'dispatcher'

Redmine::Plugin.register :redmine_embedded_video do
 name 'Redmine Embedded Video'
 author 'Nikolay Kotlyarov, PhobosK'
 description 'Embeds attachment videos, video URLs or Youtube videos. Usage (as macro): video(ID|URL|YOUTUBE_URL). Updated to SWFObject 2 and JW Player 5.10'
 url 'http://www.redmine.org/issues/5171'
 version '0.0.2'
end

Redmine::WikiFormatting::Macros.register do
   desc "Wiki video embedding"

    macro :video do |o, args|
        @width = args[1].gsub(/\D/,'') if args[1]
        @height = args[2].gsub(/\D/,'') if args[2]
        @width ||= 400
        @height ||= 300
        @num ||= 0
        @num = @num + 1
        attachment = o.attachments.find_by_filename(args[0]) if o.respond_to?('attachments')

        if attachment
            file_url = url_for (:only_path => false, :controller => 'attachments', :action => 'download', :id => attachment, :filename => attachment.filename)
        else
            file_url = args[0].gsub(/<.*?>/, '').gsub(/&lt;.*&gt;/,'')
        end
<<END
<script type='text/javascript' src='#{request.protocol}#{request.host_with_port}#{ActionController::Base.relative_url_root}/plugin_assets/redmine_embedded_video/swfobject.js'></script>
<p id="video_#{@num}">Please install the Flash Plugin</p>

<script type="text/javascript">
  var flashvars = { file:'#{file_url}',autostart:'false' };
  var params = { allowfullscreen:'true', allowscriptaccess:'always' };
  var attributes = { id:'player', name:'player' };
  swfobject.embedSWF('#{request.protocol}#{request.host_with_port}#{ActionController::Base.relative_url_root}/plugin_assets/redmine_embedded_video/player.swf','video_#{@num}','#{@width}','#{@height}','9.0.115','false',
    flashvars, params, attributes);
</script>
END
  end
end
